import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;

public class ClickListener extends MouseAdapter {
   private JTextArea debugText;
   private boolean
      leftPressed = false,
      rightPressed = false,
      bothPressed = false,
      leftReleased = false,
      rightReleased = false;
   private String buttonLabel;
   Sea.SeaButton myButton;

   public ClickListener(JTextArea debugText, Sea.SeaButton myButton) {
      //Save a reference to the debug output object.
      this.debugText = debugText;
      this.myButton = myButton;
      buttonLabel = myButton.buttonLabel;
   }

   public void mousePressed(MouseEvent e) {
      if(SwingUtilities.isLeftMouseButton(e))
         leftPressed = true;
      if(SwingUtilities.isRightMouseButton(e))
         rightPressed = true;
      if(leftPressed && rightPressed)
         bothPressed = true;
   }//End mousePressed.

   public void mouseReleased(MouseEvent e) {
      if(bothPressed) {
         if(SwingUtilities.isLeftMouseButton(e))
            leftReleased = true;
         if(SwingUtilities.isRightMouseButton(e))
            rightReleased = true;
         if(leftReleased && rightReleased) {
            bothClick();
            clearAll();
         }
      } else { //Single click.
         if(SwingUtilities.isLeftMouseButton(e) && leftPressed) {
            leftClick();
         } else if(SwingUtilities.isRightMouseButton(e) && rightPressed) {
            rightClick();
         }
         clearAll();
      }
   }//End mouseReleased.

   private void clearAll() {
      leftPressed = rightPressed = false;
      bothPressed = false;
      leftReleased = rightReleased = false;
   }

   void bothClick() {
      debugText.append(buttonLabel + "Both click\n");
      myButton.revealAdjacent();
   }

   void leftClick() {
      /* Left click is the "reveal" function.  It reveals the contents of
         the cell, which can be a mine or an adjacent mine count.  If a mine,
         you lose.  If an adjacent mine count of zero, the reveal spreads to
         reveal a boundary ring of non-zero adjacent mine counts. */
      debugText.append(buttonLabel + "Left click\n");
      myButton.reveal();
      //First leftClick in a new game starts the timer.
      Game.started = true;
   }

   void rightClick() {
      debugText.append(buttonLabel + "Right click\n");
      myButton.mark();
   }

}//End ClickListener.