//GameMenu.java - Part of Bill's Java MineSweeper
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;

public class GameMenu extends JMenu {
   MyMines parent;

   GameMenu(final MyMines parent) {
      super("Game");
      this.parent = parent;
      //Items on the Game menu.
      JMenuItem
         gNew = new JMenuItem("New"),
         gBestTimes = new JMenuItem("Best Times..."),
         gExit = new JMenuItem("Exit");
      JCheckBoxMenuItem
         gBeginner = new JCheckBoxMenuItem("Beginner",true),
         gIntermediate = new JCheckBoxMenuItem("Intermediate"),
         gExpert = new JCheckBoxMenuItem("Expert"),
         gCustom = new JCheckBoxMenuItem("Custom..."),
         gMarks = new JCheckBoxMenuItem("Marks(?)", false),
         gColor = new JCheckBoxMenuItem("Color",true);
      ButtonGroup playerLevel = new ButtonGroup();

      gNew.addActionListener(new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            parent.setupNewGame(false);
         }
      });

      gBeginner.addActionListener(new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            Game.setBeginner();
            parent.setupNewGame(true);
         }
      });

      gIntermediate.addActionListener(new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            Game.setIntermediate();
            parent.setupNewGame(true);
         }
      });

      gExpert.addActionListener(new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            Game.setExpert();
            parent.setupNewGame(true);
         }
      });

      gExit.addActionListener(new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            parent.game.dispose();
         }
      });

      gMarks.addActionListener(new ActionListener() {
         public void actionPerformed(ActionEvent e) {
            if(((JCheckBoxMenuItem)e.getSource()).isSelected()) {
               Game.questionMarks = true;
            } else {
               Game.questionMarks = false;
            }
         }
      });

      gBestTimes.setEnabled(false);
      gCustom.setEnabled(false);

      //Build the Game menu.
      add(gNew);
      addSeparator();
      add(gBeginner);
      add(gIntermediate);
      add(gExpert);
      add(gCustom);
      addSeparator();
      add(gMarks);
      add(gColor);
      add(gBestTimes);
      addSeparator();
      add(gExit);
      playerLevel.add(gBeginner);
      playerLevel.add(gIntermediate);
      playerLevel.add(gExpert);
      playerLevel.add(gCustom);
   }

}//End GameMenu.
